
# Bedrock

## Developer(s): Joey Kimsey

This library utilizes the MVC architecture in addition to a custom templating engine designed to make building web applications fast and simple.

Bedrock is the core functionality used by [The Tempus Project](https://github.com/TheTempusProject/TheTempusProject) a rapid prototyping framework.  It provides database support, configuration, base models, and base controller functionality a in addition to a host of other integrated functions.

This Library can be utilized outside of TheTempusProject, but the functionality has not been tested well as a stand-alone library.

**Notice: This Library is provided as is, please use at your own risk.**

## Installation and Use

The easiest way to use Bedrock in your application is to install it via composer and extend the main app inside of the bin folder.

`Composer.json`

```json
"require": {
    "TheTempusProject/Bedrock": "*",
},

"autoload": {
    "psr-4": {
        "TheTempusProject\\Bedrock\\": "vendor/thetempusproject/bedrock",
    }
}
```

`app.php`

```php
<?php
namespace MyApp;

use TheTempusProject\Bedrock\Bin\Bedrock;

class MyApp extends Bedrock {
    // Stuff and Things
}
?>
```

If you prefer to handle auto-loading via other means, you can simply clone this repository wherever you need it.

### To-Do

- [ ] Expansion of PDO to allow different database types
- [ ] Updates for configs and models to re-build based on a delta model, to make version changes simpler. (Migration system)
- [ ] Implement better uniformity in terms of error reporting, exceptions, logging.
